﻿using UnityEngine;
using System.Collections;
using System;
using System.Linq;
using System.Runtime.InteropServices;


public class rolleyballrtcmix : MonoBehaviour {
	float distance;
	int objno = 0;  // change for additional RTcmix objects

	void Start () {
		while (DLL.check_context() == 1) System.Threading.Thread.Sleep (1);
		DLL.RTcmix_init(objno);

		// set it for single-precision float samples (see RTcmix_API.h), scaled between -1.0 and 1.0, 2 chans;
		while (DLL.check_context() == 1) System.Threading.Thread.Sleep (1);
		DLL.RTcmix_setAudioBufferFormat(8, 2, objno);

		// note the "1024" here, vs. "2048" in the Unity code
		// this is the difference between 'frames' and 'nsamples'
		while (DLL.check_context() == 1) System.Threading.Thread.Sleep (1);
		DLL.RTcmix_setparams(44100, 2, 1024, 1, 32, objno); // '32' is the nmber of RTcmix busses

		String score = "MAXBANG(0)";
		SendScore (score);
	}
		

	// Update is called once per frame
	void Update () {
		GameObject mysticcube = GameObject.Find ("mysticcube");
		Transform mystictransform = mysticcube.transform;
		distance = Vector3.Distance (mystictransform.position, transform.position);

		Debug.Log (distance);
	}


	void OnApplicationQuit(){
		while (DLL.check_context() == 1) System.Threading.Thread.Sleep (1);
		DLL.RTcmix_destroy (objno); // reset RTcmix
	}


	// this function is called by unity for every buffer of sound samples computed
	void OnAudioFilterRead(float[] data, int channels){
		unsafe{
			fixed (float* b = data) {
				while (DLL.check_context() == 1) System.Threading.Thread.Sleep (1);
				// null input, synthesis only.  If you were processing sound, the (void *)null
				// would be replaced by (void *)b
				// Also, 1024 instead of 2048 because it is frames, not nsamples
				DLL.RTcmix_runAudio((void *)null, (void *)b, 1024, objno);


				// uncomment this to process MAXBANGs
				if (DLL.unity_checkForBang(objno) == 1) {
					float unitybright = distance-1;
					if (unitybright > 10) unitybright = 10;

					String score = "brightness = " + unitybright +
						"  STRUM2(0, 2.1, 10000, 6.00, brightness, 2.1, 0.5) " +
						"STRUM2(0, 2.1, 10000, 6.00+irand(0, 0.003), brightness, 2.1, 0.5) " +
						"STRUM2(0, 2.1, 10000, 5.00, brightness, 2.1, 0.5) " +
						"STRUM2(0, 2.1, 10000, 5.00+irand(0, 0.003), brightness, 2.1, 0.5) " +
						"MAXBANG(0.3) ";
					SendScore(score);
				}


			}
		}
	}


	// this is the score-sending function
	public void SendScore(String score) {
		IntPtr sptr = Marshal.StringToHGlobalAnsi(score);
		unsafe {
			while (DLL.check_context() == 1) System.Threading.Thread.Sleep (1);
			DLL.unity_parse_score ((char*)sptr.ToPointer (), score.Length, objno);
		}
		Marshal.FreeHGlobal(sptr);
	}

}
